window.Gleam.initSearch([{"doc":"bungibindies","title":"bungibindies","content":"# bungibindies\n\n(incomplete) Gleam bindings to the Bun runtime API&#39;s.\n\n[![Package Version](https://img.shields.io/hexpm/v/bungibindies)](https://hex.pm/packages/bungibindies)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/bungibindies/)\n\n&gt; WARNING - INCOMPLETE:\n&gt;\n&gt; Please note, not everything is implemented as of yet.\n&gt; See the [progress](https://hexdocs.pm/bungibindies/PROGRESS.html) section for more information.\n\n```sh\ngleam add bungibindies@1\n```\n\nThis is a little example I borrowed from the tests:\n\n```gleam\npub fn file_write_test() {\n  let data = &quot;Hello world! This file is for testing writing :)&quot;\n  let file = bun.file(&quot;./test/testfiles/writing.txt&quot;)\n  use _ &lt;- promise.await({ file |&gt; bun.write(data) })\n  // If `file_read_test()` fails, this will fail too\n  use read_data &lt;- promise.await({ file |&gt; bunfile.text() })\n  read_data\n  |&gt; string.trim()\n  |&gt; should.equal(data)\n  |&gt; promise.resolve()\n}}\n```\n\nI will be adding more examples to an example folder as I go along.\n\nFurther documentation can be found at &lt;https://hexdocs.pm/bungibindies&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n\n### Dependencies\n\nI try to not use anything else than Bun itself,\nbut I do use `gleam/javascript` to use non-bun-specific JavaScript stuff.\n","url":"index.html"},{"doc":"bungibindies","title":"bungibindies","content":"# Implementation\n\nBoxes are checked when the implementation is _usable_, if it&#39;s not\ncomplete but checked, should be in the `skipped` section along\nwith possibly the reason for skipping.\n\n- [ ] HTTP API&#39;s\n\n  - [x] HTTP server\n    - [x] `Bun.serve()`, `serve.fetch()` and alike\n      - [ ] `Server` type methods\n    - [ ] WebSocket server\n  - [ ] HTTP client\n    - [ ] `Bun.fetch()`\n\n- [ ] Bundler\n\n  - [ ] `Bun.bundle()`\n\n- Workers\n\n- [ ] Binary data\n\n  - [ ] Types\n\n- [ ] Streams\n\n  - [ ] Stream types\n  - [ ] Stream API&#39;s\n\n- [x] File I/O\n\n  - [x] `Bunfile` type\n  - [x] Reading (`Bun.file()` ...)\n    - [x] `Bun.file()`, `Bun.text()`, `Bun.json()` ...\n    - [x] `Bun.stdin`\n    - [x] `Bun.stdout`\n    - [x] `Bun.stderr`\n  - [x] Writing (`Bun.write()`)\n\n- import.meta\n\n- [ ] SQLite\n\n  - [x] `new()`\n  - [x] `query()`\n  - [x] `prepare()`\n  - [x] `run()`\n  - [x] `get()`\n  - [x] `all()`\n  - [ ] `iterate()`\n  - [ ] `values()`\n  - [ ] `finalise()`\n  - [x] `close()`\n\n- Globals\n\n- [ ] $ Shell -- if possible to implement\n\n- [ ] Child processes\n\n  - [ ] `Bun.spawn()`\n  - [ ] `Bun.exec()`\n  - [ ] `Bun.execSync()`\n  - [ ] `Bun.spawnSync()`\n\n- [ ] TCP\n\n  - [ ] `Bun.listen()`\n  - [ ] `Bun.connect()`\n\n- [ ] Transpiler\n\n  - [ ] `New` returning a `Bun.Transpiler` in the form of\n        a set of functions and interfaces.\n\n- [ ] Hashing\n\n  - [ ] `Bun.password_hash()` and `Bun.password_verify()`\n  - [ ] `Bun.hash()`\n\n- Console\n\n- [ ] FFI\n- [ ] HTMLRewriter\n- [ ] Testing\n- [x] Utilities\n\n  - [x] `Bun.version`\n  - [x] `Bun.revision`\n  - [x] `Bun.env`\n  - [x] `Bun.main`\n  - [x] `Bun.sleep()`\n  - [x] `Bun.sleepSync()`\n  - [x] `Bun.which()`\n  - [x] `Bun.randomUUIDv7()`\n  - [x] `Bun.peek()`\n  - [x] `Bun.openInEditor()`\n  - [x] `Bun.deepEquals()`\n  - [x] `Bun.escapeHTML()`\n  - [x] `Bun.stringWidth()`\n  - [x] `Bun.fileURLToPath()`\n  - [x] `Bun.pathToFileURL()`\n  - `Bun.gzipSync`\n  - `Bun.gunzipSync`\n  - `Bun.deflateSync`\n  - `Bun.inflateSync`\n  - [x] `Bun.inspect()`\n  - [x] `Bun.nanoseconds()`\n  - `Bun.readableStreamTo*()`\n  - [x] `Bun.resolveSync()`\n  - `serialize` &amp; `deserialize` in `bun:jsc`\n\n- DNS\n\n#### Skipped\n\nSome implementations were skipped for now. Here is a little list of what I skipped.\nIf you want to help, feel free to implement them and make a PR,\nor wait until I get to them :)\n\n- Utilities -&gt; `Bun.gzipSync`: Not sure how to implement this yet.\n- Utilities -&gt; `Bun.gunzipSync`: Not sure how to implement this yet.\n- Utilities -&gt; `Bun.deflateSync`: Not sure how to implement this yet.\n- Utilities -&gt; `Bun.inflateSync`: Not sure how to implement this yet.\n- Utilities -&gt; `Bun.readableStreamTo*()`: Not sure how to implement this.\n- Utilities -&gt; `serialize` &amp; `deserialize` in `bun:jsc`:\n  Not sure how to implement this.\n- Console: Not sure how to implement this yet.\n- DNS: Not stable enough yet.\n- `import.meta`: Gleam modules are not accessible from Bun\n  API&#39;s, maybe through source maps in the future.\n- Workers: Not stable enough yet.\n- Globals: Not relevant to the scope of this library. (Mostly contains\n  browser-related globals. Some Bun ones, but those ought to be\n  implemented elsewhere.)\n- SQLite\n  - `Query.as()`: I don&#39;t think this would fit into the Gleam language.\n\n#### Workarounds\n\nNo documented workarounds right now.\n","url":"PROGRESS.html"},{"doc":"bungibindies","title":"runs_in_bun","content":"pub fn runs_in_bun() -&gt; Result(Nil, Nil)\n Check if running in the Bun runtime. Returns `Ok(Nil)` if running in Bun, `Error(Nil)` otherwise.\nSynonyms:\nbungibindies.runs_in_bun\nbungibindies runs_in_bun","url":"bungibindies.html#runs_in_bun"},{"doc":"bungibindies","title":"bungibindies","content":"","url":"bungibindies.html"},{"doc":"bungibindies/bun/bunfile","title":"BunFile","content":"pub type BunFile\n A `BunFile` represents a lazily-loaded file; initializing it does not actually read the file from disk.\n\nSynonyms:\nbungibindies/bun/bunfile.BunFile\nbungibindies/bun/bunfile BunFile","url":"bungibindies/bun/bunfile.html#BunFile"},{"doc":"bungibindies/bun/bunfile","title":"json","content":"pub fn json(file: BunFile) -&gt; Promise(Dynamic)\n [`Bunfile.json()`](https://bun.sh/docs/api/file-io#reading-files-bun-file)\n - File I/O\n\n Read the contents of a file as a JSON object.\nSynonyms:\nbungibindies/bun/bunfile.json\nbungibindies/bun/bunfile json","url":"bungibindies/bun/bunfile.html#json"},{"doc":"bungibindies/bun/bunfile","title":"stderr","content":"pub fn stderr() -&gt; BunFile\n [`Bun.stderr`](https://bun.sh/docs/api/file-io#writing-files-bun-write)\n - File I/O\n\n Write to stderr\nSynonyms:\nbungibindies/bun/bunfile.stderr\nbungibindies/bun/bunfile stderr","url":"bungibindies/bun/bunfile.html#stderr"},{"doc":"bungibindies/bun/bunfile","title":"stdin","content":"pub fn stdin() -&gt; BunFile\n [`Bun.stdin`](https://bun.sh/docs/api/file-io#reading-files-bun-file)\n - File I/O\n \n Read from stdin\n \nThis is read-only\nSynonyms:\nbungibindies/bun/bunfile.stdin\nbungibindies/bun/bunfile stdin","url":"bungibindies/bun/bunfile.html#stdin"},{"doc":"bungibindies/bun/bunfile","title":"stdout","content":"pub fn stdout() -&gt; BunFile\n [`Bun.stdout`](https://bun.sh/docs/api/file-io#writing-files-bun-write)\n - File I/O\n \n Write to stdout\nSynonyms:\nbungibindies/bun/bunfile.stdout\nbungibindies/bun/bunfile stdout","url":"bungibindies/bun/bunfile.html#stdout"},{"doc":"bungibindies/bun/bunfile","title":"text","content":"pub fn text(file: BunFile) -&gt; Promise(String)\n [`Bunfile.text()`](https://bun.sh/docs/api/file-io#reading-files-bun-file)\n - File I/O\n\n Read the contents of a file as a string.\nSynonyms:\nbungibindies/bun/bunfile.text\nbungibindies/bun/bunfile text","url":"bungibindies/bun/bunfile.html#text"},{"doc":"bungibindies/bun/bunfile","title":"bungibindies/bun/bunfile","content":" A `BunFile` represents a lazily-loaded file; initializing it does not actually read the file from disk.\n \n &gt; **Note from Bun** — The `Bun.file` and `Bun.write` APIs documented on this page are heavily optimized and represent the recommended way to perform file-system tasks using Bun. For operations that are not yet available with `Bun.file`, such as `mkdir` or `readdir`, you can use Bun&#39;s [nearly complete](https://bun.sh/docs/runtime/nodejs-apis#node-fs) implementation of the [`node:fs`](https://nodejs.org/api/fs.html) module.","url":"bungibindies/bun/bunfile.html"},{"doc":"bungibindies/bun/http/serve/request","title":"Request","content":"pub type Request\n A request to the server\n\nSynonyms:\nbungibindies/bun/http/serve/request.Request\nbungibindies/bun/http/serve/request Request","url":"bungibindies/bun/http/serve/request.html#Request"},{"doc":"bungibindies/bun/http/serve/request","title":"headers","content":"pub fn headers(req: Request) -&gt; Array(#(String, String))\n\nSynonyms:\nbungibindies/bun/http/serve/request.headers\nbungibindies/bun/http/serve/request headers","url":"bungibindies/bun/http/serve/request.html#headers"},{"doc":"bungibindies/bun/http/serve/request","title":"integrity","content":"pub fn integrity(req: Request) -&gt; String\n\nSynonyms:\nbungibindies/bun/http/serve/request.integrity\nbungibindies/bun/http/serve/request integrity","url":"bungibindies/bun/http/serve/request.html#integrity"},{"doc":"bungibindies/bun/http/serve/request","title":"keepalive","content":"pub fn keepalive(req: Request) -&gt; Bool\n\nSynonyms:\nbungibindies/bun/http/serve/request.keepalive\nbungibindies/bun/http/serve/request keepalive","url":"bungibindies/bun/http/serve/request.html#keepalive"},{"doc":"bungibindies/bun/http/serve/request","title":"method","content":"pub fn method(req: Request) -&gt; String\n\nSynonyms:\nbungibindies/bun/http/serve/request.method\nbungibindies/bun/http/serve/request method","url":"bungibindies/bun/http/serve/request.html#method"},{"doc":"bungibindies/bun/http/serve/request","title":"mode","content":"pub fn mode(req: Request) -&gt; String\n\nSynonyms:\nbungibindies/bun/http/serve/request.mode\nbungibindies/bun/http/serve/request mode","url":"bungibindies/bun/http/serve/request.html#mode"},{"doc":"bungibindies/bun/http/serve/request","title":"new","content":"pub fn new() -&gt; Request\n\nSynonyms:\nbungibindies/bun/http/serve/request.new\nbungibindies/bun/http/serve/request new","url":"bungibindies/bun/http/serve/request.html#new"},{"doc":"bungibindies/bun/http/serve/request","title":"referrer","content":"pub fn referrer(req: Request) -&gt; String\n\nSynonyms:\nbungibindies/bun/http/serve/request.referrer\nbungibindies/bun/http/serve/request referrer","url":"bungibindies/bun/http/serve/request.html#referrer"},{"doc":"bungibindies/bun/http/serve/request","title":"set_body","content":"pub fn set_body(req: Request, body: a) -&gt; Request\n\nSynonyms:\nbungibindies/bun/http/serve/request.set_body\nbungibindies/bun/http/serve/request set_body","url":"bungibindies/bun/http/serve/request.html#set_body"},{"doc":"bungibindies/bun/http/serve/request","title":"set_headers","content":"pub fn set_headers(\n  req: Request,\n  headers: Array(#(String, String)),\n) -&gt; Request\n\nSynonyms:\nbungibindies/bun/http/serve/request.set_headers\nbungibindies/bun/http/serve/request set_headers","url":"bungibindies/bun/http/serve/request.html#set_headers"},{"doc":"bungibindies/bun/http/serve/request","title":"set_method","content":"pub fn set_method(req: Request, method: String) -&gt; Request\n\nSynonyms:\nbungibindies/bun/http/serve/request.set_method\nbungibindies/bun/http/serve/request set_method","url":"bungibindies/bun/http/serve/request.html#set_method"},{"doc":"bungibindies/bun/http/serve/request","title":"set_url","content":"pub fn set_url(req: Request, url: String) -&gt; Request\n\nSynonyms:\nbungibindies/bun/http/serve/request.set_url\nbungibindies/bun/http/serve/request set_url","url":"bungibindies/bun/http/serve/request.html#set_url"},{"doc":"bungibindies/bun/http/serve/request","title":"url","content":"pub fn url(req: Request) -&gt; String\n\nSynonyms:\nbungibindies/bun/http/serve/request.url\nbungibindies/bun/http/serve/request url","url":"bungibindies/bun/http/serve/request.html#url"},{"doc":"bungibindies/bun/http/serve/request","title":"bungibindies/bun/http/serve/request","content":"","url":"bungibindies/bun/http/serve/request.html"},{"doc":"bungibindies/bun/http/serve/response","title":"Response","content":"pub type Response\n The response to a request\n\nSynonyms:\nbungibindies/bun/http/serve/response.Response\nbungibindies/bun/http/serve/response Response","url":"bungibindies/bun/http/serve/response.html#Response"},{"doc":"bungibindies/bun/http/serve/response","title":"clone","content":"pub fn clone(res: Response) -&gt; Response\n\nSynonyms:\nbungibindies/bun/http/serve/response.clone\nbungibindies/bun/http/serve/response clone","url":"bungibindies/bun/http/serve/response.html#clone"},{"doc":"bungibindies/bun/http/serve/response","title":"headers","content":"pub fn headers(res: Response) -&gt; Array(#(String, String))\n\nSynonyms:\nbungibindies/bun/http/serve/response.headers\nbungibindies/bun/http/serve/response headers","url":"bungibindies/bun/http/serve/response.html#headers"},{"doc":"bungibindies/bun/http/serve/response","title":"new","content":"pub fn new() -&gt; Response\n\nSynonyms:\nbungibindies/bun/http/serve/response.new\nbungibindies/bun/http/serve/response new","url":"bungibindies/bun/http/serve/response.html#new"},{"doc":"bungibindies/bun/http/serve/response","title":"ok","content":"pub fn ok(res: Response) -&gt; Bool\n\nSynonyms:\nbungibindies/bun/http/serve/response.ok\nbungibindies/bun/http/serve/response ok","url":"bungibindies/bun/http/serve/response.html#ok"},{"doc":"bungibindies/bun/http/serve/response","title":"redirected","content":"pub fn redirected(res: Response) -&gt; Bool\n\nSynonyms:\nbungibindies/bun/http/serve/response.redirected\nbungibindies/bun/http/serve/response redirected","url":"bungibindies/bun/http/serve/response.html#redirected"},{"doc":"bungibindies/bun/http/serve/response","title":"set_body","content":"pub fn set_body(res: Response, body: a) -&gt; Response\n\nSynonyms:\nbungibindies/bun/http/serve/response.set_body\nbungibindies/bun/http/serve/response set_body","url":"bungibindies/bun/http/serve/response.html#set_body"},{"doc":"bungibindies/bun/http/serve/response","title":"set_headers","content":"pub fn set_headers(\n  res: Response,\n  headers: Array(#(String, String)),\n) -&gt; Response\n\nSynonyms:\nbungibindies/bun/http/serve/response.set_headers\nbungibindies/bun/http/serve/response set_headers","url":"bungibindies/bun/http/serve/response.html#set_headers"},{"doc":"bungibindies/bun/http/serve/response","title":"set_status","content":"pub fn set_status(res: Response, status: Int) -&gt; Response\n\nSynonyms:\nbungibindies/bun/http/serve/response.set_status\nbungibindies/bun/http/serve/response set_status","url":"bungibindies/bun/http/serve/response.html#set_status"},{"doc":"bungibindies/bun/http/serve/response","title":"set_status_text","content":"pub fn set_status_text(\n  res: Response,\n  status_text: String,\n) -&gt; Response\n\nSynonyms:\nbungibindies/bun/http/serve/response.set_status_text\nbungibindies/bun/http/serve/response set_status_text","url":"bungibindies/bun/http/serve/response.html#set_status_text"},{"doc":"bungibindies/bun/http/serve/response","title":"status","content":"pub fn status(res: Response) -&gt; Int\n\nSynonyms:\nbungibindies/bun/http/serve/response.status\nbungibindies/bun/http/serve/response status","url":"bungibindies/bun/http/serve/response.html#status"},{"doc":"bungibindies/bun/http/serve/response","title":"status_text","content":"pub fn status_text(res: Response) -&gt; String\n\nSynonyms:\nbungibindies/bun/http/serve/response.status_text\nbungibindies/bun/http/serve/response status_text","url":"bungibindies/bun/http/serve/response.html#status_text"},{"doc":"bungibindies/bun/http/serve/response","title":"type_","content":"pub fn type_(res: Response) -&gt; String\n &quot;basic&quot; | &quot;cors&quot; | &quot;default&quot; | &quot;error&quot; | &quot;opaque&quot; | &quot;opaqueredirect&quot;\nSynonyms:\nbungibindies/bun/http/serve/response.type_\nbungibindies/bun/http/serve/response type_","url":"bungibindies/bun/http/serve/response.html#type_"},{"doc":"bungibindies/bun/http/serve/response","title":"url","content":"pub fn url(res: Response) -&gt; String\n\nSynonyms:\nbungibindies/bun/http/serve/response.url\nbungibindies/bun/http/serve/response url","url":"bungibindies/bun/http/serve/response.html#url"},{"doc":"bungibindies/bun/http/serve/response","title":"bungibindies/bun/http/serve/response","content":"","url":"bungibindies/bun/http/serve/response.html"},{"doc":"bungibindies/bun/http/serve","title":"ServeOptions","content":"pub type ServeOptions {\n  ServeOptions(\n    development: Option(Bool),\n    hostname: Option(String),\n    port: Option(Int),\n    static_served: Option(Map(String, Response)),\n    handler: fn(Request) -&gt; Promise(Response),\n    id: Option(String),\n    reuse_port: Option(Bool),\n  )\n}\n\nServeOptions(\n  development: Option(Bool),\n  hostname: Option(String),\n  port: Option(Int),\n  static_served: Option(Map(String, Response)),\n  handler: fn(Request) -&gt; Promise(Response),\n  id: Option(String),\n  reuse_port: Option(Bool),\n)\n\nhostname\n&lt;p&gt;The hostname to listen on.&lt;/p&gt;\n\nport\n&lt;p&gt;The port to listen on.&lt;/p&gt;\n\nstatic_served\n&lt;p&gt;Server static Response objects by route.&lt;/p&gt;\n\nhandler\n&lt;p&gt;Handle dynamic requests.&lt;/p&gt;\n\nid\n&lt;p&gt;Uniquely identify a server instance with an ID&lt;/p&gt;\n\nreuse_port\n&lt;p&gt;Whether to reuse the port or not.&lt;/p&gt;\n\nSynonyms:\nbungibindies/bun/http/serve.ServeOptions\nbungibindies/bun/http/serve ServeOptions","url":"bungibindies/bun/http/serve.html#ServeOptions"},{"doc":"bungibindies/bun/http/serve","title":"Server","content":"pub type Server\n\n\nSynonyms:\nbungibindies/bun/http/serve.Server\nbungibindies/bun/http/serve Server","url":"bungibindies/bun/http/serve.html#Server"},{"doc":"bungibindies/bun/http/serve","title":"bungibindies/bun/http/serve","content":"","url":"bungibindies/bun/http/serve.html"},{"doc":"bungibindies/bun","title":"deep_equals","content":"pub fn deep_equals(a: a, b: a) -&gt; Bool\n [`Bun.deepEquals()`](https://bun.sh/docs/api/utils#bun-deepequals)\n - Utilities\n\n &gt; Recursively checks if two objects are equivalent. This is used internally by `expect().toEqual()` in `bun/test`.\nSynonyms:\nbungibindies/bun.deep_equals\nbungibindies/bun deep_equals","url":"bungibindies/bun.html#deep_equals"},{"doc":"bungibindies/bun","title":"deep_equals_strict","content":"pub fn deep_equals_strict(a: a, b: a) -&gt; Bool\n [`Bun.deepEquals()`](https://bun.sh/docs/api/utils#bun-deepequals)\n - Utilities\n\n &gt; Recursively checks if two objects are equivalent. This is used internally by `expect().toEqual()` in `bun/test`.\nSynonyms:\nbungibindies/bun.deep_equals_strict\nbungibindies/bun deep_equals_strict","url":"bungibindies/bun.html#deep_equals_strict"},{"doc":"bungibindies/bun","title":"env","content":"pub fn env(key: String) -&gt; Result(String, Nil)\n [`Bun.env`](https://bun.sh/docs/api/utils#bun-env)\n - Utilities\n\n &gt; Fetches the value of an environment variable.\nSynonyms:\nbungibindies/bun.env\nbungibindies/bun env","url":"bungibindies/bun.html#env"},{"doc":"bungibindies/bun","title":"escape_html","content":"pub fn escape_html(value: a) -&gt; String\n [`Bun.escapeHTML()`](https://bun.sh/docs/api/utils#bun-escapehtml)\n - Utilities\n\n &gt; `Bun.escapeHTML(value: string | object | number | boolean): string`\n Escapes the following characters from an input string:\n\n &gt; - `&quot;` becomes `&amp;quot;`\n - `&amp;` becomes `&amp;amp;`\n - `&#39;` becomes `&amp;#x27;`\n - `&lt;` becomes `&amp;lt;`\n - `&gt;` becomes `&amp;gt;`\n\n &gt; This function is optimized for large input. On an M1X, it processes 480 MB/s -\n 20 GB/s, depending on how much data is being escaped and whether there is non-ascii\n text. Non-string types will be converted to a string before escaping.\nSynonyms:\nbungibindies/bun.escape_html\nbungibindies/bun escape_html","url":"bungibindies/bun.html#escape_html"},{"doc":"bungibindies/bun","title":"file","content":"pub fn file(path: String) -&gt; BunFile\n [`Bun.file()`](https://bun.sh/docs/api/fs#bun-file)\n - File I/O\n\n Create a BunFile instance with the `Bun.file(path)` function.\nSynonyms:\nbungibindies/bun.file\nbungibindies/bun file","url":"bungibindies/bun.html#file"},{"doc":"bungibindies/bun","title":"file_url_to_path","content":"pub fn file_url_to_path(url: String) -&gt; String\n [`Bun.fileURLToPath()`](https://bun.sh/docs/api/utils#bun-fileurltopath)\n - Utilities\n\n &gt; Converts a file URL to a file path.\nSynonyms:\nbungibindies/bun.file_url_to_path\nbungibindies/bun file_url_to_path","url":"bungibindies/bun.html#file_url_to_path"},{"doc":"bungibindies/bun","title":"inspect","content":"pub fn inspect(value: a) -&gt; String\n [`Bun.inspect()`](https://bun.sh/docs/api/utils#bun-inspect)\n - Utilities\n\n &gt; Returns a string representation of an object.\nSynonyms:\nbungibindies/bun.inspect\nbungibindies/bun inspect","url":"bungibindies/bun.html#inspect"},{"doc":"bungibindies/bun","title":"main_","content":"pub fn main_() -&gt; String\n [`Bun.main`](https://bun.sh/docs/api/utils#bun-main)\n - Utilities\n\n &gt; An absolute path to the entrypoint javascript module of the current program (the file that was executed with bun run).\nSynonyms:\nbungibindies/bun.main_\nbungibindies/bun main_","url":"bungibindies/bun.html#main_"},{"doc":"bungibindies/bun","title":"nanoseconds","content":"pub fn nanoseconds() -&gt; Float\n [`Bun.nanoseconds()`](https://bun.sh/docs/api/utils#bun-nanoseconds)\n - Utilities\n\n &gt; Returns the number of nanoseconds since the current `bun` process started, as a `number`. Useful for high-precision timing and benchmarking.\nSynonyms:\nbungibindies/bun.nanoseconds\nbungibindies/bun nanoseconds","url":"bungibindies/bun.html#nanoseconds"},{"doc":"bungibindies/bun","title":"open_in_editor","content":"pub fn open_in_editor(path: String) -&gt; Nil\n [`Bun.openInEditor()`](https://bun.sh/docs/api/utils#bun-openineditor)\n - Utilities\n\n &gt; Opens a file in the user&#39;s editor.\nSynonyms:\nbungibindies/bun.open_in_editor\nbungibindies/bun open_in_editor","url":"bungibindies/bun.html#open_in_editor"},{"doc":"bungibindies/bun","title":"open_in_editor_with_options","content":"pub fn open_in_editor_with_options(\n  path: String,\n  options: Map(String, String),\n) -&gt; Nil\n [`Bun.openInEditor()`](https://bun.sh/docs/api/utils#bun-openineditor)\n - Utilities\n\n &gt; Opens a file in the user&#39;s editor.\nSynonyms:\nbungibindies/bun.open_in_editor_with_options\nbungibindies/bun open_in_editor_with_options","url":"bungibindies/bun.html#open_in_editor_with_options"},{"doc":"bungibindies/bun","title":"path_to_file_url","content":"pub fn path_to_file_url(path: String) -&gt; String\n [`Bun.pathToFileURL()`](https://bun.sh/docs/api/utils#bun-pathtofileurl)\n - Utilities\n\n &gt; Converts a file path to a file URL.\nSynonyms:\nbungibindies/bun.path_to_file_url\nbungibindies/bun path_to_file_url","url":"bungibindies/bun.html#path_to_file_url"},{"doc":"bungibindies/bun","title":"peek","content":"pub fn peek(promise: Promise(a)) -&gt; Result(a, Nil)\n [`Bun.peek()`](https://bun.sh/docs/api/utils#bun-peek)\n - Utilities\n\n &gt; Reads a promise&#39;s result without await or .then, but only if the promise has already fulfilled or rejected.\nSynonyms:\nbungibindies/bun.peek\nbungibindies/bun peek","url":"bungibindies/bun.html#peek"},{"doc":"bungibindies/bun","title":"random_uuid_v7","content":"pub fn random_uuid_v7() -&gt; String\n [`Bun.randomUUIDv7()](https://bun.sh/docs/api/utils#bun-randomuuidv7)\n - Utilities\n\n &gt; Returns a UUID v7, which is monotonic and suitable for sorting and databases.\nSynonyms:\nbungibindies/bun.random_uuid_v7\nbungibindies/bun random_uuid_v7","url":"bungibindies/bun.html#random_uuid_v7"},{"doc":"bungibindies/bun","title":"random_uuid_v7_buffer","content":"pub fn random_uuid_v7_buffer() -&gt; Array(Int)\n [`Bun.randomUUIDv7()`](https://bun.sh/docs/api/utils#bun-randomuuidv7)\n - Utilities\n\n &gt; Returns a UUID v7, which is monotonic and suitable for sorting and databases as a buffer.\nSynonyms:\nbungibindies/bun.random_uuid_v7_buffer\nbungibindies/bun random_uuid_v7_buffer","url":"bungibindies/bun.html#random_uuid_v7_buffer"},{"doc":"bungibindies/bun","title":"resolve_sync","content":"pub fn resolve_sync(module: String, parent: String) -&gt; String\n [`Bun.resolveSync()`](https://bun.sh/docs/api/utils#bun-resolvesync)\n - Utilities\n\n &gt; Resolves a file path or module specifier using Bun&#39;s internal module resolution algorithm. The first argument is the path to resolve, and the second argument is the &quot;root&quot;. If no match is found, an `Error` is thrown.\nSynonyms:\nbungibindies/bun.resolve_sync\nbungibindies/bun resolve_sync","url":"bungibindies/bun.html#resolve_sync"},{"doc":"bungibindies/bun","title":"revision","content":"pub fn revision() -&gt; String\n [`Bun.revision`](https://bun.sh/docs/api/utils#bun-revision)\n - Utilities\n\n &gt; A string containing the git revision of the bun CLI that is currently running.\nSynonyms:\nbungibindies/bun.revision\nbungibindies/bun revision","url":"bungibindies/bun.html#revision"},{"doc":"bungibindies/bun","title":"serve","content":"pub fn serve(serve_options: ServeOptions) -&gt; Server\n [`Bun.serve()`](https://bun.sh/docs/api/http#start-a-server-bun-serve)\n - HTTP -&gt; Server\n \n Start an HTTP server in Bun with `Bun.serve`.\nSynonyms:\nbungibindies/bun.serve\nbungibindies/bun serve","url":"bungibindies/bun.html#serve"},{"doc":"bungibindies/bun","title":"sleep","content":"pub fn sleep(ms: Float) -&gt; Nil\n [`Bun.sleep()`](https://bun.sh/docs/api/utils#bun-sleep)\n - Utilities\n\n &gt; Sleeps for the given number of milliseconds.\nSynonyms:\nbungibindies/bun.sleep\nbungibindies/bun sleep","url":"bungibindies/bun.html#sleep"},{"doc":"bungibindies/bun","title":"sleep_sync","content":"pub fn sleep_sync(ms: Float) -&gt; Nil\n [`Bun.sleepSync()`](https://bun.sh/docs/api/utils#bun-sleepsync)\n - Utilities\n\n &gt; Sleeps for the given number of milliseconds synchronously.\nSynonyms:\nbungibindies/bun.sleep_sync\nbungibindies/bun sleep_sync","url":"bungibindies/bun.html#sleep_sync"},{"doc":"bungibindies/bun","title":"string_width","content":"pub fn string_width(\n  value: String,\n  count_ansi_escape_codes: Bool,\n  ambiguous_is_narrow: Bool,\n) -&gt; Int\n [`Bun.stringWidth()`](https://bun.sh/docs/api/utils#bun-stringwidth)\n - Utilities\n\n &gt; Get the column count of a string as it would be displayed in a terminal.\n Supports ANSI escape codes, emoji, and wide characters.\nSynonyms:\nbungibindies/bun.string_width\nbungibindies/bun string_width","url":"bungibindies/bun.html#string_width"},{"doc":"bungibindies/bun","title":"version","content":"pub fn version() -&gt; String\n [`Bun.version`](https://bun.sh/docs/api/utils#bun-version)\n - Utilities\n\n &gt; A string containing the version of the bun CLI that is currently running.\nSynonyms:\nbungibindies/bun.version\nbungibindies/bun version","url":"bungibindies/bun.html#version"},{"doc":"bungibindies/bun","title":"which","content":"pub fn which(executable: String) -&gt; Result(String, Nil)\n [`Bun.which()`](https://bun.sh/docs/api/utils#bun-which)\n - Utilities\n\n &gt; Returns the path to the given executable if it is in the PATH.\nSynonyms:\nbungibindies/bun.which\nbungibindies/bun which","url":"bungibindies/bun.html#which"},{"doc":"bungibindies/bun","title":"which_with_options","content":"pub fn which_with_options(\n  executable: String,\n  options: Map(String, String),\n) -&gt; Result(String, Nil)\n [`Bun.which()`](https://bun.sh/docs/api/utils#bun-which)\n - Utilities\n\n &gt; Returns the path to the given executable if it is in the PATH\nSynonyms:\nbungibindies/bun.which_with_options\nbungibindies/bun which_with_options","url":"bungibindies/bun.html#which_with_options"},{"doc":"bungibindies/bun","title":"write","content":"pub fn write(destination: BunFile, data: a) -&gt; Promise(Int)\n [`Bun.write()`](https://bun.sh/docs/api/fs#bun-write)\n - File I/O\n\n The `Bun.write` function is a multi-tool for writing payloads of all kinds to disk.\n\n @param destination — The file to write to\n @param data — The data to copy into destination.\n @returns — A promise that resolves with the number of bytes written.\nSynonyms:\nbungibindies/bun.write\nbungibindies/bun write","url":"bungibindies/bun.html#write"},{"doc":"bungibindies/bun","title":"bungibindies/bun","content":" Gleam bindings to the Bun runtime API&#39;s.","url":"bungibindies/bun.html"},{"doc":"bungibindies/bun/ffi","title":"bungibindies/bun/ffi","content":" # `Bun:ffi` module","url":"bungibindies/bun/ffi.html"},{"doc":"bungibindies/bun/sqlite/param_array","title":"ParamArray","content":"pub type ParamArray\n An implementation of javascript&#39;s `Array` type, but unlike the gleam/javascript/array module, this one allows for the use of `Any` as a type parameter.\n This also means Gleam should not be touching this type, let Bun handle that.\n\nSynonyms:\nbungibindies/bun/sqlite/param_array.ParamArray\nbungibindies/bun/sqlite/param_array ParamArray","url":"bungibindies/bun/sqlite/param_array.html#ParamArray"},{"doc":"bungibindies/bun/sqlite/param_array","title":"list_to_paramarray","content":"pub fn list_to_paramarray(li: List(a)) -&gt; ParamArray\n Create a param array from a List.\nSynonyms:\nbungibindies/bun/sqlite/param_array.list_to_paramarray\nbungibindies/bun/sqlite/param_array list_to_paramarray","url":"bungibindies/bun/sqlite/param_array.html#list_to_paramarray"},{"doc":"bungibindies/bun/sqlite/param_array","title":"new","content":"pub fn new() -&gt; ParamArray\n Create a new `ParamArray` instance.\nSynonyms:\nbungibindies/bun/sqlite/param_array.new\nbungibindies/bun/sqlite/param_array new","url":"bungibindies/bun/sqlite/param_array.html#new"},{"doc":"bungibindies/bun/sqlite/param_array","title":"push","content":"pub fn push(array: ParamArray, value: a) -&gt; ParamArray\n Add a value to the end of the array.\nSynonyms:\nbungibindies/bun/sqlite/param_array.push\nbungibindies/bun/sqlite/param_array push","url":"bungibindies/bun/sqlite/param_array.html#push"},{"doc":"bungibindies/bun/sqlite/param_array","title":"bungibindies/bun/sqlite/param_array","content":"","url":"bungibindies/bun/sqlite/param_array.html"},{"doc":"bungibindies/bun/sqlite","title":"Database","content":"pub type Database\n The `Database` type is an instance of a database collection.\n\nSynonyms:\nbungibindies/bun/sqlite.Database\nbungibindies/bun/sqlite Database","url":"bungibindies/bun/sqlite.html#Database"},{"doc":"bungibindies/bun/sqlite","title":"RunResult","content":"pub type RunResult {\n  RunResult(last_insert_row_id: Int, changes: Int)\n}\n The `RunResult` type is an object with two properties: `lastInsertRowid` and `changes`.\n It is emitted by the `run` function.\nRunResult(last_insert_row_id: Int, changes: Int)\n\n\nSynonyms:\nbungibindies/bun/sqlite.RunResult\nbungibindies/bun/sqlite RunResult","url":"bungibindies/bun/sqlite.html#RunResult"},{"doc":"bungibindies/bun/sqlite","title":"Statement","content":"pub type Statement\n A `Statement` is a _prepared query_, which means it&#39;s been parsed and compiled into an efficient binary form. It can be executed multiple times in a performant way.\n\nSynonyms:\nbungibindies/bun/sqlite.Statement\nbungibindies/bun/sqlite Statement","url":"bungibindies/bun/sqlite.html#Statement"},{"doc":"bungibindies/bun/sqlite","title":"all","content":"pub fn all(\n  statement: Statement,\n  params: ParamArray,\n) -&gt; Array(Dynamic)\n [`all`](https://bun.sh/docs/api/sqlite)\n - Sqlite\n \n Use `.all()` to run a query and get back the results as an array of objects.\nSynonyms:\nbungibindies/bun/sqlite.all\nbungibindies/bun/sqlite all","url":"bungibindies/bun/sqlite.html#all"},{"doc":"bungibindies/bun/sqlite","title":"close","content":"pub fn close(db: Database) -&gt; Nil\n [`close()`](https://bun.sh/docs/api/sqlite)\n - Sqlite\n \n Use `.close()` to close the database connection.\nSynonyms:\nbungibindies/bun/sqlite.close\nbungibindies/bun/sqlite close","url":"bungibindies/bun/sqlite.html#close"},{"doc":"bungibindies/bun/sqlite","title":"get","content":"pub fn get(statement: Statement, params: ParamArray) -&gt; Dynamic\n [`get`](https://bun.sh/docs/api/sqlite)\n - Sqlite\n \n Use `.get()` to run a query and get back the first result as an object.\nSynonyms:\nbungibindies/bun/sqlite.get\nbungibindies/bun/sqlite get","url":"bungibindies/bun/sqlite.html#get"},{"doc":"bungibindies/bun/sqlite","title":"new","content":"pub fn new(to: String) -&gt; Database\n [`bun:sqlite.Database -&gt; New()`](https://bun.sh/docs/api/sqlite)\n - Sqlite\n\n Create a new database connection\nSynonyms:\nbungibindies/bun/sqlite.new\nbungibindies/bun/sqlite new","url":"bungibindies/bun/sqlite.html#new"},{"doc":"bungibindies/bun/sqlite","title":"prepare","content":"pub fn prepare(db: Database, query: String) -&gt; Statement\n [`bun:sqlite.Statement -&gt; prepare()`](https://bun.sh/docs/api/sqlite)\n - Sqlite\n\n Use the `db.prepare()` method on your `Database` instance to [prepare](https://www.sqlite.org/c3ref/prepare.html) a SQL query. The result is a `Statement` instance that will NOT be cached on the `Database` instance. _The query will not be executed.\n &gt; **Note** — Use the `.query()` method to prepare a query _with_ caching it on the `Database` instance.\nSynonyms:\nbungibindies/bun/sqlite.prepare\nbungibindies/bun/sqlite prepare","url":"bungibindies/bun/sqlite.html#prepare"},{"doc":"bungibindies/bun/sqlite","title":"query","content":"pub fn query(db: Database, query: String) -&gt; Statement\n [`bun:sqlite.Database -&gt; query()`](https://bun.sh/docs/api/sqlite)\n - Sqlite\n\n Use the `db.query()` method on your `Database` instance to [prepare](https://www.sqlite.org/c3ref/prepare.html) a SQL query. The result is a `Statement` instance that will be cached on the `Database` instance. _The query will not be executed.\n &gt; **Note** — Use the `.prepare()` method to prepare a query _without_ caching it on the `Database` instance.\nSynonyms:\nbungibindies/bun/sqlite.query\nbungibindies/bun/sqlite query","url":"bungibindies/bun/sqlite.html#query"},{"doc":"bungibindies/bun/sqlite","title":"run","content":"pub fn run(statement: Statement, params: ParamArray) -&gt; RunResult\n [`bun:sqlite.run()`](https://bun.sh/docs/api/sqlite)\n - Sqlite\n \n Use `.run()` to run a query and get back a `RunResult`. This is useful for schema-modifying queries (e.g. `CREATE TABLE`) or bulk write operations.\n\n Internally, this calls [`sqlite3_reset`](https://www.sqlite.org/capi3ref.html#sqlite3_reset) and calls [`sqlite3_step`](https://www.sqlite.org/capi3ref.html#sqlite3_step) once. Stepping through all the rows is not necessary when you don&#39;t care about the results.\n The `lastInsertRowid` property returns the ID of the last row inserted into the database. The `changes` property is the number of rows affected by the query.\nSynonyms:\nbungibindies/bun/sqlite.run\nbungibindies/bun/sqlite run","url":"bungibindies/bun/sqlite.html#run"},{"doc":"bungibindies/bun/sqlite","title":"bungibindies/bun/sqlite","content":" # `Bun:sqlite` module","url":"bungibindies/bun/sqlite.html"},{"doc":"bungibindies/bun/t_st","title":"bungibindies/bun/t_st","content":" # `Bun:test` module","url":"bungibindies/bun/t_st.html"}]);